#ifndef __BUZZ_H
#define __BUZZ_H

#include "machineinterface.h"
#include "outmachine.h"

#define MAX_OUTS					32
#define NUM_OUTS					8

#pragma pack(1)                        

class avals
{
public:

	int dummy;        			
};

class gvals
{
public:            

	word dummy;		
};

class tvals
{
public:            

	byte dummy;		
};

#pragma pack()

class mi;
class miex : public CMachineInterfaceEx 
{
public:

	virtual char const	*DescribeParam(int const param);			
	virtual void		GetSubMenu(int const i, CMachineDataOutput *pout){};			
	
	mi					*pmi;	
};

class mi : public CMachineInterface
{
public:

	mi();
	virtual				~mi();

	virtual void		Tick();			                        
	virtual bool		Work(float *psamples, int numsamples, int const mode);
	virtual bool		WorkMonoToStereo(float *pin, float *pout, int numsamples, int const mode);
	virtual void		Init(CMachineDataInput * const pi);
	virtual void		Save(CMachineDataOutput * const po);
	virtual void		Command(int const i);            
	virtual void		SetNumTracks(int const n);
	virtual char const	*DescribeValue(int const param, int const value);
	virtual void		OutputModeChanged(bool stereo) {}
	virtual void		AttributesChanged();			
	virtual void		MidiNote(int const channel, int const value, int const velocity);			
	virtual	void		Stop();		

public:

	CMachine*			cm;
	miex				ex;

	avals				aval;
	gvals				gval;
	tvals				tval[32];

	int					numTracks;
	
	COutputs			outs;
	OUTS				om;
	
};

#endif